/*
 *  libfb - FreeBASIC's runtime library
 *	Copyright (C) 2004-2005 Andre V. T. Vicentini (av1ctor@yahoo.com.br) and others.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * io_inkey.c -- inkey$ function for DOS console mode apps
 *
 * chng: jan/2005 written [DrV]
 *
 */

#include "fb.h"

#include <conio.h>

/*:::::*/
FBSTRING *fb_ConsoleInkey( void )
{
	FBSTRING	*res;
	unsigned int	k;
	int		chars;

	if( _conio_kbhit( ) )
	{
		chars = 1;
		k = (unsigned int)getch( );
		if( k == 0x00 || k == 0xE0 )
		{
			k = (unsigned int)getch( );
			chars = 2;
		}

        res = fb_hStrAllocTemp( NULL, chars );
        DBG_ASSERT( res!=NULL );
        if( chars > 1 )
            res->data[0] = FB_EXT_CHAR; /* note: can't use '\0' here as in qb */

        res->data[chars-1] = (unsigned char)k;
        res->data[chars-0] = '\0';

        /* Reset the status for "key buffer changed" when a key
         * was removed from the input queue. */
        fb_hConsoleInputBufferChanged();
    }
	else
		res = &fb_strNullDesc;

	return res;
}

/*:::::*/
int fb_ConsoleGetkey( void )
{
	int k = 0;

	k = getch( );
	if( k == 0x00 || k == 0xE0 )
		k = getch( );

    /* Reset the status for "key buffer changed" when a key
     * was removed from the input queue. */
    fb_hConsoleInputBufferChanged();

	return k;
}

/*:::::*/
int fb_ConsoleKeyHit( void )
{

	return _conio_kbhit( );

}

