/*
 *  libfb - FreeBASIC's runtime library
 *	Copyright (C) 2004-2005 Andre V. T. Vicentini (av1ctor@yahoo.com.br) and others.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * strw_chr.c -- chrw$ routine
 *
 * chng: oct/2004 written [v1ctor]
 *
 */

#include <stdarg.h>
#include "fb.h"

/*:::::*/
FB_WCHAR *fb_WstrChr ( int args, ... )
{
	FB_WCHAR 	*dst, *s;
	va_list 	ap;
	unsigned int num;
	int i;

	if( args <= 0 )
		return NULL;

	/* alloc temp string */
	va_start( ap, args );

    dst = fb_wstr_AllocTemp( args );
	if( dst != NULL )
	{
		/* convert */
		s = dst;
		for( i = 0; i < args; i++ )
		{
			num = va_arg( ap, unsigned int );
			*s++ = num;
		}
		/* null-term */
		*s = 0;
	}

	va_end( ap );

	return dst;
}

