/*
 *  libfb - FreeBASIC's runtime library
 *	Copyright (C) 2004-2005 Andre V. T. Vicentini (av1ctor@yahoo.com.br) and others.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * intl_get.c -- get i18n data
 *
 * chng: aug/2005 written [mjs]
 *
 */

#include "fbext.h"

/*:::::*/
const char *fb_DrvIntlGet( eFbIntlIndex Index )
{
    static char achBuffer[128];
    switch ( Index ) {
    case eFIL_DateDivider:
        if( fb_hGetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_SDATE,
                               achBuffer, sizeof(achBuffer) - 1 )==0 ) {
            return NULL;
        }
        break;
    case eFIL_TimeDivider:
        if( fb_hGetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_STIME,
                               achBuffer, sizeof(achBuffer) - 1 )==0 ) {
            return NULL;
        }
        break;
    case eFIL_NumDecimalPoint:
        if( fb_hGetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_SDECIMAL,
                               achBuffer, sizeof(achBuffer) - 1 )==0 ) {
            return NULL;
        }
        break;
    case eFIL_NumThousandsSeparator:
        if( fb_hGetLocaleInfo( LOCALE_USER_DEFAULT, LOCALE_STHOUSAND,
                               achBuffer, sizeof(achBuffer) - 1 )==0 ) {
            return NULL;
        }
        break;
    default:
        return NULL;
    }
    return achBuffer;
}
